/*
   +----------------------------------------------------------------------+
   | unkown license:                                                      |
   +----------------------------------------------------------------------+
   +----------------------------------------------------------------------+
*/

/* $ Id: $ */ 

// {{{ CREATE and DROP statements for this UDF

/*
register the functions provided by this UDF module using
CREATE FUNCTION const_check RETURNS STRING SONAME "constant.so";

unregister the functions provided by this UDF module using
DROP FUNCTION const_check;
*/
// }}}

// {{{ standard header stuff
#ifdef STANDARD
#include <stdio.h>
#include <string.h>
#ifdef __WIN__
typedef unsigned __int64 ulonglong; /* Microsofts 64 bit types */
typedef __int64 longlong;
#else
typedef unsigned long long ulonglong;
typedef long long longlong;
#endif /*__WIN__*/
#else
#include <my_global.h>
#include <my_sys.h>
#endif
#include <mysql.h>
#include <m_ctype.h>
#include <m_string.h>       // To get strmov()

// }}}

#ifdef HAVE_DLOPEN

#include "udf_constant.h"

// {{{ prototypes

#ifdef  __cplusplus
extern "C" {
#endif
/* FUNCTION const_check */
my_bool const_check_init(UDF_INIT *initid, UDF_ARGS *args, char *message);
char * const_check(UDF_INIT *initid, UDF_ARGS *args, char *result, unsigned long *length, char *is_null, char *error);
void const_check_deinit(UDF_INIT *initid);

#ifdef  __cplusplus
}
#endif
// }}}

// {{{ UDF functions

static int const_flag;

// {{{ FUNCTION const_check RETURNS STRING
/* const_check init function */
my_bool const_check_init(UDF_INIT *initid, UDF_ARGS *args, char *message)
{
    const_flag = (args->args[0]) ? 1 : 0;
    return 0;
}

/* const_check deinit function */
void const_check_deinit(UDF_INIT *initid)
{
  return;
}

/* const_check actual processing function */
char * const_check(UDF_INIT *initid, UDF_ARGS *args, char *result, unsigned long *length, char *is_null, char *error)
{
    if (const_flag) {
      sprintf(result, "check: constant\n");
    } else {
      sprintf(result, "check: not constant\n");
    }
  *is_null=0;

  *length=strlen(result);

  return result;
}

// }}}

// }}}

#else
#error your installation does not support loading UDFs
#endif /* HAVE_DLOPEN */

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
